Loading...
Searching...
No Matches
pcl::io Namespace Reference

## Namespaces

namespace | depth_sense
namespace | openni2
namespace | ply
namespace | real_sense

## Classes

class | AverageBuffer
| A buffer that computes running window average of the data inserted. More...
class | Buffer
| An abstract base class for fixed-size data buffers. More...
struct | CameraParameters
| Basic camera parameters placeholder. More...
struct | CompressionPointTraits
struct | CompressionPointTraits< PointXYZRGB >
struct | CompressionPointTraits< PointXYZRGBA >
struct | configurationProfile_t
class | DeBayer
| Various debayering methods. More...
class | DepthImage
| This class provides methods to fill a depth or disparity image. More...
class | FrameWrapper
| Pure abstract interface to wrap native frame data types. More...
class | Image
| Image interface class providing an interface to fill a RGB or Grayscale image buffer. More...
class | ImageRGB24
| This class provides methods to fill a RGB or Grayscale image buffer from underlying RGB24 image. More...
class | ImageYUV422
| Concrete implementation of the interface Image for a YUV 422 image used by Primesense devices. More...
class | IOException
| General IO exception class. More...
class | IRImage
| Class containing just a reference to IR meta data. More...
class | LZFBayer8ImageReader
| PCL-LZF 8-bit Bayer image format reader. More...
class | LZFBayer8ImageWriter
| PCL-LZF 8-bit Bayer image format writer. More...
class | LZFDepth16ImageReader
| PCL-LZF 16-bit depth image format reader. More...
class | LZFDepth16ImageWriter
| PCL-LZF 16-bit depth image format writer. More...
class | LZFImageReader
| PCL-LZF image format reader. More...
class | LZFImageWriter
| PCL-LZF image format writer. More...
class | LZFRGB24ImageReader
| PCL-LZF 24-bit RGB image format reader. More...
class | LZFRGB24ImageWriter
| PCL-LZF 24-bit RGB image format writer. More...
class | LZFYUV422ImageReader
| PCL-LZF 8-bit Bayer image format reader. More...
class | LZFYUV422ImageWriter
| PCL-LZF 16-bit YUV422 image format writer. More...
class | MedianBuffer
| A buffer that computes running window median of the data inserted. More...
class | OctreePointCloudCompression
| Octree pointcloud compression class More...
struct | OrganizedConversion
struct | OrganizedConversion< PointT, false >
struct | OrganizedConversion< PointT, true >
class | OrganizedPointCloudCompression
class | PointCloudImageExtractor
| Base Image Extractor class for organized point clouds. More...
class | PointCloudImageExtractorFromCurvatureField
| Image Extractor which uses the data present in the "curvature" field to produce a curvature map (as a monochrome image with mono16 encoding). More...
class | PointCloudImageExtractorFromIntensityField
| Image Extractor which uses the data present in the "intensity" field to produce a monochrome intensity image (with mono16 encoding). More...
class | PointCloudImageExtractorFromLabelField
| Image Extractor which uses the data present in the "label" field to produce either monochrome or RGB image where different labels correspond to different colors. More...
class | PointCloudImageExtractorFromNormalField
| Image Extractor which uses the data present in the "normal" field. More...
class | PointCloudImageExtractorFromRGBField
| Image Extractor which uses the data present in the "rgb" or "rgba" fields to produce a color image with rgb8 encoding. More...
class | PointCloudImageExtractorFromZField
| Image Extractor which uses the data present in the "z" field to produce a depth map (as a monochrome image with mono16 encoding). More...
class | PointCloudImageExtractorWithScaling
| Image Extractor extension which provides functionality to apply scaling to the values extracted from a field. More...
class | SingleBuffer
| A simple buffer that only stores data. More...
struct | TARHeader
| A TAR file's header, as described on https://en.wikipedia.org/wiki/Tar_%28file_format%29. More...

## Enumerations

enum

compression_Profiles_e {
LOW_RES_ONLINE_COMPRESSION_WITHOUT_COLOR , LOW_RES_ONLINE_COMPRESSION_WITH_COLOR , MED_RES_ONLINE_COMPRESSION_WITHOUT_COLOR , MED_RES_ONLINE_COMPRESSION_WITH_COLOR ,
HIGH_RES_ONLINE_COMPRESSION_WITHOUT_COLOR , HIGH_RES_ONLINE_COMPRESSION_WITH_COLOR , LOW_RES_OFFLINE_COMPRESSION_WITHOUT_COLOR , LOW_RES_OFFLINE_COMPRESSION_WITH_COLOR ,
MED_RES_OFFLINE_COMPRESSION_WITHOUT_COLOR , MED_RES_OFFLINE_COMPRESSION_WITH_COLOR , HIGH_RES_OFFLINE_COMPRESSION_WITHOUT_COLOR , HIGH_RES_OFFLINE_COMPRESSION_WITH_COLOR ,
COMPRESSION_PROFILE_COUNT , MANUAL_CONFIGURATION
}

## Functions

template<std::size_t N>
void | swapByte (char *bytes)
| swap bytes order of a char array of length N
template<>
void | swapByte< 1 > (char *bytes)
| specialization of swapByte for dimension 1
template<>
void | swapByte< 2 > (char *bytes)
| specialization of swapByte for dimension 2
template<>
void | swapByte< 4 > (char *bytes)
| specialization of swapByte for dimension 4
template<>
void | swapByte< 8 > (char *bytes)
| specialization of swapByte for dimension 8
template<typename T >
void | swapByte (T &value)
| swaps byte of an arbitrary type T casting it to char*
PCL_EXPORTS void | encodeMonoImageToPNG (std::vector< std::uint8_t > &image_arg, std::size_t width_arg, std::size_t height_arg, std::vector< std::uint8_t > &pngData_arg, int png_level_arg=-1)
| Encodes 8-bit mono image to PNG format.
PCL_EXPORTS void | encodeMonoImageToPNG (std::vector< std::uint16_t > &image_arg, std::size_t width_arg, std::size_t height_arg, std::vector< std::uint8_t > &pngData_arg, int png_level_arg=-1)
| Encodes 16-bit mono image to PNG format.
PCL_EXPORTS void | encodeRGBImageToPNG (std::vector< std::uint8_t > &image_arg, std::size_t width_arg, std::size_t height_arg, std::vector< std::uint8_t > &pngData_arg, int png_level_arg=-1)
| Encodes 8-bit RGB image to PNG format.
PCL_EXPORTS void | encodeRGBImageToPNG (std::vector< std::uint16_t > &image_arg, std::size_t width_arg, std::size_t height_arg, std::vector< std::uint8_t > &pngData_arg, int png_level_arg=-1)
| Encodes 16-bit RGB image to PNG format.
PCL_EXPORTS void | decodePNGToImage (std::vector< std::uint8_t > &pngData_arg, std::vector< std::uint8_t > &imageData_arg, std::size_t &width_arg, std::size_t &heigh_argt, unsigned int &channels_arg)
| Decode compressed PNG to 8-bit image.
PCL_EXPORTS void | decodePNGToImage (std::vector< std::uint8_t > &pngData_arg, std::vector< std::uint16_t > &imageData_arg, std::size_t &width_arg, std::size_t &height_arg, unsigned int &channels_arg)
| Decode compressed PNG to 16-bit image.
PCL_EXPORTS int | load (const std::string &file_name, pcl::PCLPointCloud2 &blob)
| Load a file into a PointCloud2 according to extension.
template<typename PointT >
int | load (const std::string &file_name, pcl::PointCloud< PointT > &cloud)
| Load a file into a template PointCloud type according to extension.
PCL_EXPORTS int | load (const std::string &file_name, pcl::PolygonMesh &mesh)
| Load a file into a PolygonMesh according to extension.
PCL_EXPORTS int | load (const std::string &file_name, pcl::TextureMesh &mesh)
| Load a file into a TextureMesh according to extension.
PCL_EXPORTS int | save (const std::string &file_name, const pcl::PCLPointCloud2 &blob, unsigned precision=5)
| Save point cloud data to a binary file when available else to ASCII.
template<typename PointT >
int | save (const std::string &file_name, const pcl::PointCloud< PointT > &cloud)
| Save point cloud to a binary file when available else to ASCII.
PCL_EXPORTS int | save (const std::string &file_name, const pcl::TextureMesh &tex_mesh, unsigned precision=5)
| Saves a TextureMesh to a binary file when available else to ASCII.
PCL_EXPORTS int | save (const std::string &file_name, const pcl::PolygonMesh &mesh, unsigned precision=5)
| Saves a PolygonMesh to a binary file when available else to ASCII.
int | loadIFSFile (const std::string &file_name, pcl::PCLPointCloud2 &cloud)
| Load an IFS file into a PCLPointCloud2 blob type.
template<typename PointT >
int | loadIFSFile (const std::string &file_name, pcl::PointCloud< PointT > &cloud)
| Load any IFS file into a templated PointCloud type.
int | loadIFSFile (const std::string &file_name, pcl::PolygonMesh &mesh)
| Load any IFS file into a PolygonMesh type.
int | saveIFSFile (const std::string &file_name, const pcl::PCLPointCloud2 &cloud)
| Save point cloud data to an IFS file containing 3D points.
template<typename PointT >
int | saveIFSFile (const std::string &file_name, const pcl::PointCloud< PointT > &cloud)
| Save point cloud data to an IFS file containing 3D points.
void | throwIOException (const char *function, const char *file, unsigned line, const char *format,...)
int | raw_open (const char *pathname, int flags, int mode)
int | raw_open (const char *pathname, int flags)
int | raw_close (int fd)
int | raw_lseek (int fd, long offset, int whence)
int | raw_read (int fd, void *buffer, std::size_t count)
int | raw_write (int fd, const void *buffer, std::size_t count)
int | raw_ftruncate (int fd, long length)
int | raw_fallocate (int fd, long length)
PCL_EXPORTS void | saveCharPNGFile (const std::string &file_name, const unsigned char *mono_image, int width, int height, int channels)
| Saves 8-bit encoded image to PNG file.
PCL_EXPORTS void | saveShortPNGFile (const std::string &file_name, const unsigned short *short_image, int width, int height, int channels)
| Saves 16-bit encoded image to PNG file.
PCL_EXPORTS void | saveRgbPNGFile (const std::string &file_name, const unsigned char *rgb_image, int width, int height)
| Saves 8-bit encoded RGB image to PNG file.
PCL_EXPORTS void | savePNGFile (const std::string &file_name, const pcl::PointCloud< unsigned char > &cloud)
| Saves 8-bit grayscale cloud as image to PNG file.
PCL_EXPORTS void | savePNGFile (const std::string &file_name, const pcl::PointCloud< unsigned short > &cloud)
| Saves 16-bit grayscale cloud as image to PNG file.
PCL_EXPORTS void | savePNGFile (const std::string &file_name, const pcl::PCLImage &image)
| Saves a PCLImage (formerly ROS sensor_msgs::Image) to PNG file.
template<typename PointT >
void | savePNGFile (const std::string &file_name, const pcl::PointCloud< PointT > &cloud, const std::string &field_name)
| Saves the data from the specified field of the point cloud as image to PNG file.
template<typename PointT >
bool | saveTARPointCloud (const std::string &, const PointCloud< PointT > &, const std::string &)
| Save a PointCloud dataset into a TAR file.
PCL_EXPORTS int | saveVTKFile (const std::string &file_name, const pcl::PolygonMesh &triangles, unsigned precision=5)
| Saves a PolygonMesh in ascii VTK format.
PCL_EXPORTS int | saveVTKFile (const std::string &file_name, const pcl::PCLPointCloud2 &cloud, unsigned precision=5)
| Saves a PointCloud in ascii VTK format.
PCL_EXPORTS int | vtk2mesh (const vtkSmartPointer< vtkPolyData > &poly_data, pcl::PolygonMesh &mesh)
| Convert vtkPolyData object to a PCL PolygonMesh.
PCL_EXPORTS int | vtk2mesh (const vtkSmartPointer< vtkPolyData > &poly_data, pcl::TextureMesh &mesh)
| Convert vtkPolyData object to a PCL TextureMesh.
PCL_EXPORTS int | mesh2vtk (const pcl::PolygonMesh &mesh, vtkSmartPointer< vtkPolyData > &poly_data)
| Convert a PCL PolygonMesh to a vtkPolyData object.
PCL_EXPORTS int | loadPolygonFile (const std::string &file_name, pcl::PolygonMesh &mesh)
| Load a PolygonMesh object given an input file name, based on the file extension.
PCL_EXPORTS bool | savePolygonFile (const std::string &file_name, const pcl::PolygonMesh &mesh, const bool binary_format=true)
| Save a PolygonMesh object given an input file name, based on the file extension.
PCL_EXPORTS int | loadPolygonFileVTK (const std::string &file_name, pcl::PolygonMesh &mesh)
| Load a VTK file into a PolygonMesh object.
PCL_EXPORTS int | loadPolygonFilePLY (const std::string &file_name, pcl::PolygonMesh &mesh)
| Load a PLY file into a PolygonMesh object.
PCL_EXPORTS int | loadPolygonFileOBJ (const std::string &file_name, pcl::PolygonMesh &mesh)
| Load an OBJ file into a PolygonMesh object.
PCL_EXPORTS int | loadPolygonFileOBJ (const std::string &file_name, pcl::TextureMesh &mesh)
| Load an OBJ file into a TextureMesh object.
PCL_EXPORTS int | loadPolygonFileSTL (const std::string &file_name, pcl::PolygonMesh &mesh)
| Load an STL file into a PolygonMesh object.
PCL_EXPORTS bool | savePolygonFileVTK (const std::string &file_name, const pcl::PolygonMesh &mesh, const bool binary_format=true)
| Save a PolygonMesh object into a VTK file.
PCL_EXPORTS bool | savePolygonFilePLY (const std::string &file_name, const pcl::PolygonMesh &mesh, const bool binary_format=true)
| Save a PolygonMesh object into a PLY file.
PCL_EXPORTS bool | savePolygonFileSTL (const std::string &file_name, const pcl::PolygonMesh &mesh, const bool binary_format=true)
| Save a PolygonMesh object into an STL file.
PCL_EXPORTS void | saveRangeImagePlanarFilePNG (const std::string &file_name, const pcl::RangeImagePlanar &range_image)
| Write a RangeImagePlanar object to a PNG file.
template<typename PointT >
void | pointCloudTovtkPolyData (const pcl::PointCloud< PointT > &cloud, vtkPolyData *const polydata)
| Convert a pcl::PointCloud object to a VTK PolyData one.
PCL_EXPORTS void | pointCloudTovtkPolyData (const pcl::PCLPointCloud2Ptr &cloud, vtkSmartPointer< vtkPolyData > &poly_data)
| Convert a PCLPointCloud2 object to a VTK PolyData object.
template<typename PointT >
void | pointCloudTovtkStructuredGrid (const pcl::PointCloud< PointT > &cloud, vtkStructuredGrid *const structured_grid)
| Convert a pcl::PointCloud object to a VTK StructuredGrid one.
template<typename PointT >
void | vtkPolyDataToPointCloud (vtkPolyData *const polydata, pcl::PointCloud< PointT > &cloud)
| Convert a VTK PolyData object to a pcl::PointCloud one.
template<typename PointT >
void | vtkStructuredGridToPointCloud (vtkStructuredGrid *const structured_grid, pcl::PointCloud< PointT > &cloud)
| Convert a VTK StructuredGrid object to a pcl::PointCloud one.

## Variables

const struct configurationProfile_t | compressionProfiles_ [COMPRESSION_PROFILE_COUNT]

## Enumeration Type Documentation

## compression_Profiles_e

enum pcl::io::compression_Profiles_e

Enumerator
LOW_RES_ONLINE_COMPRESSION_WITHOUT_COLOR |
LOW_RES_ONLINE_COMPRESSION_WITH_COLOR |
MED_RES_ONLINE_COMPRESSION_WITHOUT_COLOR |
MED_RES_ONLINE_COMPRESSION_WITH_COLOR |
HIGH_RES_ONLINE_COMPRESSION_WITHOUT_COLOR |
HIGH_RES_ONLINE_COMPRESSION_WITH_COLOR |
LOW_RES_OFFLINE_COMPRESSION_WITHOUT_COLOR |
LOW_RES_OFFLINE_COMPRESSION_WITH_COLOR |
MED_RES_OFFLINE_COMPRESSION_WITHOUT_COLOR |
MED_RES_OFFLINE_COMPRESSION_WITH_COLOR |
HIGH_RES_OFFLINE_COMPRESSION_WITHOUT_COLOR |
HIGH_RES_OFFLINE_COMPRESSION_WITH_COLOR |
COMPRESSION_PROFILE_COUNT |
MANUAL_CONFIGURATION |

Definition at line 44 of file compression_profiles.h.

## Function Documentation

## mesh2vtk()

PCL_EXPORTS int pcl::io::mesh2vtk | ( | const pcl::PolygonMesh & | mesh,
|  | vtkSmartPointer< vtkPolyData > & | poly_data
| ) |  |

Convert a PCL PolygonMesh to a vtkPolyData object.

Parameters

  [in] | mesh | Reference to PCL Polygon Mesh
  [out] | poly_data | Pointer (vtkSmartPointer) to a vtkPolyData object

Returns
  Number of points in the point cloud of mesh.

## raw_close()

int pcl::io::raw_close | ( | int | fd | ) |

inline

Definition at line 85 of file low_level_io.h.

Referenced by pcl::LineRGBD< PointXYZT, PointRGBT >::loadTemplates(), pcl::PCDWriter::writeBinary(), pcl::PCDWriter::writeBinary(), and pcl::PCDWriter::writeBinaryCompressed().

## raw_fallocate()

int pcl::io::raw_fallocate | ( | int | fd,
|  | long | length
| ) |  |

inline

Definition at line 110 of file low_level_io.h.

References raw_ftruncate().

Referenced by pcl::PCDWriter::writeBinary(), pcl::PCDWriter::writeBinary(), and pcl::PCDWriter::writeBinaryCompressed().

## raw_ftruncate()

int pcl::io::raw_ftruncate | ( | int | fd,
|  | long | length
| ) |  |

inline

Definition at line 105 of file low_level_io.h.

Referenced by raw_fallocate().

## raw_lseek()

int pcl::io::raw_lseek | ( | int | fd,
|  | long | offset,
|  | int | whence
| ) |  |

inline

Definition at line 90 of file low_level_io.h.

Referenced by pcl::LineRGBD< PointXYZT, PointRGBT >::loadTemplates().

## raw_open() [1/2]

int pcl::io::raw_open | ( | const char * | pathname,
|  | int | flags
| ) |  |

inline

Definition at line 80 of file low_level_io.h.

## raw_open() [2/2]

int pcl::io::raw_open | ( | const char * | pathname,
|  | int | flags,
|  | int | mode
| ) |  |

inline

Definition at line 75 of file low_level_io.h.

Referenced by pcl::LineRGBD< PointXYZT, PointRGBT >::loadTemplates(), pcl::PCDWriter::writeBinary(), pcl::PCDWriter::writeBinary(), and pcl::PCDWriter::writeBinaryCompressed().

## raw_read()

int pcl::io::raw_read | ( | int | fd,
|  | void * | buffer,
|  | std::size_t | count
| ) |  |

inline

Definition at line 95 of file low_level_io.h.

Referenced by pcl::LineRGBD< PointXYZT, PointRGBT >::loadTemplates().

## raw_write()

int pcl::io::raw_write | ( | int | fd,
|  | const void * | buffer,
|  | std::size_t | count
| ) |  |

inline

Definition at line 100 of file low_level_io.h.

## saveTARPointCloud()

template<typename PointT >

bool pcl::io::saveTARPointCloud | ( | const std::string & | ,
|  | const PointCloud< PointT > & | ,
|  | const std::string & |
| ) |  |

Save a PointCloud dataset into a TAR file.

Append if the file exists, or create a new one if not.

Remarks
  till implemented will return FALSE

Definition at line 92 of file tar.h.

## swapByte()

template<typename T >

void pcl::io::swapByte | ( | T & | value | ) |

swaps byte of an arbitrary type T casting it to char*

Parameters

  value | the data you want its bytes swapped

Definition at line 564 of file io.h.

## swapByte< 1 >()

template<>

void pcl::io::swapByte< 1 > | ( | char * | bytes | ) |

inline

specialization of swapByte for dimension 1

Parameters

  bytes | char array to swap

Definition at line 528 of file io.h.

## swapByte< 2 >()

template<>

void pcl::io::swapByte< 2 > | ( | char * | bytes | ) |

inline

specialization of swapByte for dimension 2

Parameters

  bytes | char array to swap

Definition at line 535 of file io.h.

## swapByte< 4 >()

template<>

void pcl::io::swapByte< 4 > | ( | char * | bytes | ) |

inline

specialization of swapByte for dimension 4

Parameters

  bytes | char array to swap

Definition at line 541 of file io.h.

## swapByte< 8 >()

template<>

void pcl::io::swapByte< 8 > | ( | char * | bytes | ) |

inline

specialization of swapByte for dimension 8

Parameters

  bytes | char array to swap

Definition at line 551 of file io.h.

## throwIOException()

void pcl::io::throwIOException | ( | const char * | function,
|  | const char * | file,
|  | unsigned | line,
|  | const char * | format,
|  |  | ...
| ) |  |

inline

Definition at line 96 of file io_exception.h.

## vtk2mesh() [1/2]

PCL_EXPORTS int pcl::io::vtk2mesh | ( | const vtkSmartPointer< vtkPolyData > & | poly_data,
|  | pcl::PolygonMesh & | mesh
| ) |  |

Convert vtkPolyData object to a PCL PolygonMesh.

Parameters

  [in] | poly_data | Pointer (vtkSmartPointer) to a vtkPolyData object
  [out] | mesh | PCL Polygon Mesh to fill

Returns
  Number of points in the point cloud of mesh.

## vtk2mesh() [2/2]

PCL_EXPORTS int pcl::io::vtk2mesh | ( | const vtkSmartPointer< vtkPolyData > & | poly_data,
|  | pcl::TextureMesh & | mesh
| ) |  |

Convert vtkPolyData object to a PCL TextureMesh.

Note
  In addition to the vtk2mesh (const vtkSmartPointer<vtkPolyData>&, pcl::PolygonMesh&) method, it fills the mesh with the uv-coordinates.

Parameters

  [in] | poly_data | Pointer (vtkSmartPointer) to a vtkPolyData object
  [out] | mesh | PCL TextureMesh to fill

Returns
  Number of points in the point cloud of mesh.

## Variable Documentation

## compressionProfiles_

const struct configurationProfile_t pcl::io::compressionProfiles_[COMPRESSION_PROFILE_COUNT]

Definition at line 80 of file compression_profiles.h.

Referenced by pcl::io::OctreePointCloudCompression< PointT, LeafT, BranchT, OctreeT >::initialization().